/*
	alliance.h
	
	(c) Richard Thrippleton
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

class equip;
struct cord;

class alliance //Alliance type
{
	public:
	static const short LIBSIZE=8; //Size of alliance library
	enum {COWARD,ATTACK,DEFENCE,MAKEFRIEND,DESERT,TRAVELHOME,TRAVELFRIEND,TRAVELENEMY,TORPEDO,ATTACKWILD,ATTACKSTRAIGHT,ATTACKFORMATION}; //Different behaviour actions
	enum {TRADE_NONE=0,TRADE_OPEN=1,TRADE_FRIENDS=2,TRADE_CLOSED=3}; //Trading standards constants

	static void init(); //Initialise the datastructures
	static void loadlib(); //Load the alliances from the library in the database
	static void purgeall(); //Purges the alliance data clean
	static alliance* get(short indx); //Returns alliance of given index
	static void maketerritories(); //Generate the territories for all alliances

	bool opposes(alliance* all); //Find out if this alliance opposes the given alliance
	equip* getequip(); //Get a random equipment item that this alliance stocks

	short self; //Self index
	char nam[65]; //Name
	short bhvs[32]; //Behaviour probabilities
	short sinv[16]; //Ship type inventory for this alliance
	short ripo; //Ripoff percentage for purchases (100 is normal)
	short trad; //Trading standards (see enum at top)
};
