/*
	calc.h
	
	(c) Richard Thrippleton
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

struct vect //A vector
{
	long xx;
	long yy; //X and Y components
};

struct cord //A co-ordinate in the game
{
	long x;
	long y; //X and Y components
};

struct pol //A polar vector
{
        short ang; //Angle
	long rad; //Radius
};

struct box //A universe bounding box
{
	long x1,y1; //Top-left corner
	long x2,y2; //Top-right corner
};

class calc //Mathematics module
{
	public:
	static const double mypi=3.141592654; //Not every OS defines Pi

	static void init(); //Initialise some tables
	static vect poltovect(pol in); //Take a polar, output it as a vector
	static pol vecttopol(vect in); //Take a vector, output it as a polar
	static long quickroot(long x); //Fast integer square root
	static long rnd(long max); //Return random integer from 0 to max-1
	static void getspeed(long spd,char* put); //Convert given game velocity to a string
	static long dattolong(unsigned char* in); //Converts a four byte buffer portably into a long
	static void longtodat(long in,unsigned char* out); //Puts a long portably into a four byte buffer
	static short dattoshort(unsigned char* in); //Converts a two byte buffer portably into a short
	static void shorttodat(short in,unsigned char* out); //Puts a long portably into a four byte buffer
	static bool dateq(unsigned char* d1,unsigned char* d2,short n); //Test two data streams for equality, up to n bytes
};
