/*
	camera.h
	
	(c) Richard Thrippleton
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

struct box;
struct cord;
class presence;
class sound;

class camera //Viewer of the client's universe
{
	public:
	static void init(); //Initialise camera datastructures
	static void turnon(); //Turn camera on
	static void turnoff(); //Turn camera off
	static void bind(presence* src); //Bind the camera to given source
	static void unbind(); //Camera floats free, no longer bound
	static void render(); //Render what the camera can see
	static void update(); //Update camera position
	static void noise(sound* snd,presence* src); //Play noise from given source
	static void shake(short mag); //Shake the camera with given magnitude
	static void radarzoom(short dir); //Zoom the sensor in or out, with dir +1 or -1 respectively

	static box cov; //Total camera coverage
};
