/*
	database.h
	
	(c) Richard Thrippleton
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

class database //Object database spanning multiple files
{
	public:
	static void init(); //Initialise and blank the datastructures
	static void openreader(char* path); //Opens a data file and parses it into the database
	static void openwriter(char* path); //Opens a file to write objects to
	static void closereader(); //Closes the current writer
	static void closewriter(); //Closes the current writer
	static void switchobj(char* name); //Jump to the named object in the database, returning if it was found or not
	static char* getvalue(char* key,char* val); //Get the value of the given attribute (space to put value should be specified)
	static long getvalue(char* key); //As above, but value parsed to be an integer
	static void putobject(char* name); //Write the header of an object to the open writer
	static void putvalue(char* key,char* val); //Write key=value to the open writer
	static void putvalue(char* key,long val);
};
