/*
	presence.h
	
	(c) Richard Thrippleton
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

struct box;
struct cord;

class presence //Client side view of the universe and its simple objects
{
	public:
	static const short ISIZE=2048; //Size of presence object index
	static void init(); //Initialise the presence system datastructures
	static void purgeall(); //Purge all presence data after use
	static void feed(unsigned char* buf); //Update/create a presence from a buffer
	static void interpolateall(); //Run interpolation on all the presence objects
	static presence* get(short indx); //Return the presence object of given index
	static void render(); //Render client/presence info, such as realtime information indicators
	static void controls(); //Run the in game ship controls

	void drawat(short sx,short sy); //Draw at the given screen location

	static presence* me; //Presence played by this client
	static presence* trg; //Personal target
	static presence* hl; //Hilight target
	static short hul,pow,shd,ful; //Hull, power, shield and fuel percentages
	static pol vel; //Velocity of self
	static long srng,lrng; //Sensor range and long range

	short self; //Presence object self index
	short typ; //Object type
	char nam[65]; //Name of object
	char anno[65]; //Annotative data, e.g. alliance
	cord loc; //Location
	bool enem; //Is enemy?
};
