/*
	server.h
	
	(c) Richard Thrippleton
	Licensing terms are in the 'LICENSE' file
	If that file is not included with this source then permission is not given to use this source in any way whatsoever.
*/

class ship;

class server //Controls connections to players
{
	public:
	static short const CLIENTS=32; //Maximum number of clients

	static void init(); //Initialise server datastructures
	static void start(); //Start the server listening
	static void stop(); //Stop the server and clean up all data
	static void cycle(); //Run one tick of the server
	static void notifydeath(ship* tshp); //Tells the server system that a given ship has died
	static void hail(ship* fr,ship* to,char* msg); //Send a hail from one ship to another with given message
	static void registernoise(ship* fr,short snd); //Register a noise emitted from the given ship, of given sound index
	static void registersound(ship* to,short snd); //Register a sound of given index, internal to the given ship
	static void registershake(ship* to,short mag); //Command given ship to shake
	static void transfer(ship* fr,ship* to); //Transfer player from one ship to another
	static char* playername(ship* tshp); //Return player name associated with this ship, null otherwise
};
